import { genericNode } from "@ark/schema";
import * as util from "@ark/util";
import { Hkt } from "@ark/util";
import { scope } from "../scope.js";
import { tsKeywords } from "./tsKeywords.js";
class liftArrayHkt extends Hkt {
}
const liftArray = genericNode("element")(args => args.element.or(args.element.array()).pipe(util.liftArray), liftArrayHkt);
class mergeHkt extends Hkt {
}
const merge = genericNode(["base", tsKeywords.object], ["props", tsKeywords.object])(args => args.base.merge(args.props), mergeHkt);
const arkGenericsExports = {
    liftArray,
    merge
};
const $ = scope(arkGenericsExports, {
    prereducedAliases: true
});
export const arkGenerics = $.export();
