import { rootNode } from "@ark/schema";
import { scope } from "../scope.js";
const trim = rootNode({
    in: "string",
    morphs: (s) => s.trim()
});
const uppercase = rootNode({
    in: "string",
    morphs: (s) => s.toUpperCase()
});
const lowercase = rootNode({
    in: "string",
    morphs: (s) => s.toLowerCase()
});
const capitalize = rootNode({
    in: "string",
    morphs: (s) => s.charAt(0).toUpperCase() + s.slice(1)
});
const normalize = rootNode({
    in: "string",
    morphs: (s) => s.normalize()
});
export const formatting = scope({
    trim,
    uppercase,
    lowercase,
    capitalize,
    normalize
}, {
    prereducedAliases: true
}).export();
