import { scope } from "../scope.js";
// these are needed to create some internal types
import { intrinsic, node } from "@ark/schema";
import "./tsKeywords.js";
export const internal = scope({
    lengthBoundable: intrinsic.lengthBoundable,
    key: intrinsic.key,
    nonNegativeIntegerString: intrinsic.nonNegativeIntegerString
}, {
    prereducedAliases: true
}).export();
// reduce union of all possible values reduces to unknown
node("union", {
    branches: [
        "string",
        "number",
        "object",
        "bigint",
        "symbol",
        { unit: true },
        { unit: false },
        { unit: null },
        { unit: undefined }
    ]
}, { reduceTo: node("intersection", {}, { prereduced: true }) });
