import type { Out, number } from "../ast.js";
import type { Module } from "../module.js";
declare const number: import("@ark/schema").BaseRoot<import("@ark/schema").InternalRootDeclaration>;
export type FormDataValue = string | File;
export type ParsedFormData = Record<string, FormDataValue | FormDataValue[]>;
export type parsingExports = {
    url: (In: string) => Out<URL>;
    number: (In: string) => Out<number>;
    integer: (In: string) => Out<number.divisibleBy<1>>;
    date: (In: string) => Out<Date>;
    json: (In: string) => Out<object>;
    formData: (In: FormData) => Out<ParsedFormData>;
};
export type parsing = Module<parsingExports>;
export declare const parsing: parsing;
export {};
