import type { anonymous, AtLeast, AtMost, DivisibleBy, number, string } from "../ast.js";
import type { Module } from "../module.js";
export interface validationExports {
    alpha: string.matching<anonymous>;
    alphanumeric: string.matching<anonymous>;
    digits: string.matching<anonymous>;
    lowercase: string.matching<anonymous>;
    uppercase: string.matching<anonymous>;
    creditCard: string.matching<anonymous>;
    email: string.matching<anonymous>;
    uuid: string.matching<anonymous>;
    url: string.matching<anonymous>;
    semver: string.matching<anonymous>;
    ip: string.matching<anonymous>;
    integer: number.divisibleBy<1>;
    unixTimestamp: number.is<DivisibleBy<1> & AtMost<8640000000000000> & AtLeast<-8640000000000000>>;
}
export type validation = Module<validationExports>;
export declare const validation: validation;
